#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivityNationalDayDrawLottery.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivityNationalDayDrawLottery> M_ActivityNationalDayDrawLottery::msSingleton(nullptr);

int M_ActivityNationalDayDrawLottery::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityNationalDayDrawLotteryData* M_ActivityNationalDayDrawLottery::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivityNationalDayDrawLotteryData>& M_ActivityNationalDayDrawLottery::GetMapData()
{
	return mMapData;
}

void M_ActivityNationalDayDrawLottery::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivityNationalDayDrawLottery::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityNationalDayDrawLotteryData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		{
			const char* ItemId = element->Attribute("ItemId");
			std::vector<std::string> vecItemId;
			boost::split(vecItemId, ItemId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemId[i].c_str(), &temp))
				{
					data.mItemId.push_back(temp);
				}
			}
		}
		{
			const char* Number = element->Attribute("Number");
			std::vector<std::string> vecNumber;
			boost::split(vecNumber, Number, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecNumber.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecNumber[i].c_str(), &temp))
				{
					data.mNumber.push_back(temp);
				}
			}
		}
		data.mWeight = element->IntAttribute("Weight");
		data.mDisplayLabel = element->IntAttribute("DisplayLabel");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivityNationalDayDrawLottery::Load()
{
	Load("../Config/M_ActivityNationalDayDrawLottery.xml");
}

M_ActivityNationalDayDrawLottery* M_ActivityNationalDayDrawLottery::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityNationalDayDrawLottery());
	}
	return msSingleton.get();
}
